﻿using HigLabo.Core;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HigLabo.DbSharpApplication.Core
{
    public class ConfigData
    {
        public static String FilePath = Environment.CurrentDirectory + "\\Config.xml";
        public String SchemaFilePath { get; set; }
        public ObservableCollection<String> RecentSchemaFilePathList { get; private set; }
        public MainWindowStateInfo MainWindow { get; set; }
        public GenerateSourceCodeWindowStateInfo GenerateSourceCodeWindow { get; set; }
        public WindowStateInfo ManageConnectionStringWindow { get; set; }
        public WindowStateInfo AddTableWindow { get; set; }
        public WindowStateInfo AddStoredProcedureWindow { get; set; }
        public WindowStateInfo DeleteObjectWindow { get; set; }
        public ConfigData()
        {
            this.RecentSchemaFilePathList = new ObservableCollection<string>();
            this.MainWindow = new MainWindowStateInfo()
            {
                Width = 800,
                Height = 600,
            };
            this.ManageConnectionStringWindow = new WindowStateInfo(700, 400);
            this.AddTableWindow = new WindowStateInfo(800, 500);
            this.AddStoredProcedureWindow = new WindowStateInfo(800, 500);
            this.DeleteObjectWindow = new WindowStateInfo(800, 500);
            this.GenerateSourceCodeWindow = new GenerateSourceCodeWindowStateInfo(800, 600);
        }
        public void Save()
        {
            File.WriteAllText(FilePath, Serializer.ToXml(this));
            //順番を入れ替えるため削除して追加
            AValue.ConfigData.RecentSchemaFilePathList.Remove(AValue.ConfigData.SchemaFilePath);
            AValue.ConfigData.RecentSchemaFilePathList.Insert(0, AValue.ConfigData.SchemaFilePath);
        }
        public static ConfigData LoadConfigData()
        {
            var filePath = ConfigData.FilePath;
            if (File.Exists(filePath) == true)
            {
                var xmlText = File.ReadAllText(filePath);
                try
                {
                    return Serializer.FromXml<ConfigData>(xmlText);
                }
                catch
                {
                    return new ConfigData();
                }
            }
            else
            {
                return new ConfigData();
            }
        }
    }
}
