﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace HigLabo.DbSharpApplication.Core
{
    public class GenerateSourceCodeWindowStateInfo : WindowStateInfo
    {
        public Double StoredProcedureGridColumnWidth { get; set; }
        public Double GeneratedFileGridColumn { get; set; }
        public GenerateSourceCodeWindowStateInfo()
        {
            this.StoredProcedureGridColumnWidth = 1;
            this.GeneratedFileGridColumn = 2;
        }
        public GenerateSourceCodeWindowStateInfo(Double width, Double height)
            : base(width, height)
        {
            this.StoredProcedureGridColumnWidth = 1;
            this.GeneratedFileGridColumn = 2;
        }
        protected override void InitializeProperty(Window window)
        {
            var w = window as GenerateSourceCodeWindow;
            var wsi = this;
            w.Width = wsi.Width;
            w.Height = wsi.Height;
            w.StoredProcedureGridColumn.Width = new GridLength(wsi.StoredProcedureGridColumnWidth, GridUnitType.Star);
            w.GeneratedFileGridColumn.Width = new GridLength(wsi.GeneratedFileGridColumn, GridUnitType.Star);
        }
        protected override void WindowClosing(Window window)
        {
            var w = window as GenerateSourceCodeWindow;
            var wsi = this;
            wsi.Width = w.Width;
            wsi.Height = w.Height;
            wsi.StoredProcedureGridColumnWidth = w.StoredProcedureGridColumn.Width.Value;
            wsi.GeneratedFileGridColumn = w.GeneratedFileGridColumn.Width.Value;
            AValue.ConfigData.Save();
        }
    }
}
