﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace HigLabo.DbSharpApplication.Core
{
    public class WindowStateInfo
    {
        public Double Width { get; set; }
        public Double Height { get; set; }
        public WindowStateInfo()
        {
        }
        public WindowStateInfo(Double width, Double height)
        {
            this.Width = width;
            this.Height = height;
        }
        public void Initialize(Window window)
        {
            var w = window;
            w.Closing += Window_Closing;
            this.InitializeProperty(window);
        }
        protected virtual void InitializeProperty(Window window)
        {
            var w = window;
            var wsi = this;
            w.Width = wsi.Width;
            w.Height = wsi.Height;
        }
        void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            this.WindowClosing(sender as Window);
        }
        protected virtual void WindowClosing(Window window)
        {
            var w = window;
            var wsi = this;
            wsi.Width = w.Width;
            wsi.Height = w.Height;
            AValue.ConfigData.Save();
        }
    }
}
