﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Threading;
using HigLabo.DbSharpApplication.Core;
using System.IO;
using HigLabo.Core;
using HigLabo.DbSharp.CodeGenerator;
using System.Globalization;
using System.Windows;

namespace HigLabo.DbSharpApplication.Core
{
    public class AValue
    {
        private static readonly String ErrorFolderPath = "\\ErrorLog\\";
        public static ImageSource Icon { get; private set; }
        public static ConfigData ConfigData { get; private set; }
        public static SchemaData_1 SchemaData { get; private set; }
        public static void Initialize()
        {
            AValue.ConfigData = ConfigData.LoadConfigData();
            AValue.SchemaData = new SchemaData_1();
            AValue.Icon = new BitmapImage(new Uri(Environment.CurrentDirectory + "\\Icon\\DbSharp.ico"));
            AValue.CreateErrorLogFolder();
            Properties.Resources.Culture = CultureInfo.CurrentUICulture;
            Application.Current.DispatcherUnhandledException += DispatcherUnhandledException;
        }
        static void DispatcherUnhandledException(object sender, DispatcherUnhandledExceptionEventArgs e)
        {
            e.Handled = true;
            AValue.AddErrorLog(e.Exception);
        }
        private static void CreateErrorLogFolder()
        {
            var path = Environment.CurrentDirectory + ErrorFolderPath;
            if (Directory.Exists(path) == true) { return; }
            try
            {
                Directory.CreateDirectory(path);
            }
            catch { }
        }
        public static void AddErrorLog(Exception exception)
        {
            try
            {
                var path = Environment.CurrentDirectory + ErrorFolderPath;
                var Now = DateTime.Now;
                File.WriteAllText(String.Format("{0}ErrorLog_{1}_{2}.txt"
                    , path, Now.ToString("yyyyMMdd_HHmmss_fff"), exception.GetType().Name)
                    , exception.ToString());
            }
            catch { }
        }
        public static ImageSource CreateImageSource(String url)
        {
            Uri u = null;

            if (String.IsNullOrEmpty(url) == false && Uri.TryCreate(url, UriKind.Absolute, out u) == true)
            {
                BitmapImage image = new BitmapImage();
                image.BeginInit();
                image.UriSource = u;
                image.EndInit();
                return image;
            }
            return null;
        }
        public static void LoadSchemaData(String xmlText)
        {
            if (String.IsNullOrWhiteSpace(xmlText) == true)
            {
                AValue.SchemaData = new SchemaData_1();
                return;
            }
            AValue.SchemaData = Serializer.FromXml<SchemaData_1>(xmlText);
        }
    }
}
