﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace HigLabo.DbSharpApplication
{
    /// <summary>
    /// Interaction logic for EditConnectionStringWindow.xaml
    /// </summary>
    public partial class EditConnectionStringWindow : Window
    {
        public event EventHandler<EditConnectionStringWindowSavedEventArgs> Saved;
        public EditConnectionStringWindow(String connectionString)
        {
            InitializeComponent();
            this.ConnectionStringTextBox.Text = connectionString;
        }

        private void SaveButton_Click(object sender, RoutedEventArgs e)
        {
            this.OnSaved();
            this.Close();
        }
        private void OnSaved()
        {
            var eh = this.Saved;
            if (eh != null)
            {
                eh(this, new EditConnectionStringWindowSavedEventArgs(this.ConnectionStringTextBox.Text));
            }
        }
        private void QuitButton_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
    public class EditConnectionStringWindowSavedEventArgs : EventArgs
    {
        public String ConnectionString { get; private set; }
        public EditConnectionStringWindowSavedEventArgs(String connectionString)
        {
            this.ConnectionString = connectionString;
        }
    }
}
