﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using HigLabo.DbSharpApplication.Core;
using System.Collections.ObjectModel;

namespace HigLabo.DbSharpApplication
{
    /// <summary>
    /// Interaction logic for ManageConnectionStringWindow.xaml
    /// </summary>
    public partial class ManageConnectionStringWindow : Window
    {
        public ManageConnectionStringWindow()
        {
            InitializeComponent();

            this.ConnectionStringListBox.ItemsSource = AValue.SchemaData.ConnectionStrings;
            AValue.ConfigData.ManageConnectionStringWindow.Initialize(this);
        }
        private void AddConnectionStringButton_Click(object sender, RoutedEventArgs e)
        {
            AValue.SchemaData.ConnectionStrings.Add(this.ConnectionStringTextBox.Text);
        }
        private void ConnectionStringListBox_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            this.EditConnectionString();
        }
        private void EditButton_Click(object sender, RoutedEventArgs e)
        {
            this.EditConnectionString();
        }
        private void EditConnectionString()
        {
            var s = this.ConnectionStringListBox.SelectedValue as String;
            var w = new EditConnectionStringWindow(s);
            w.Saved += EditConnectionStringWindow_Saved;
            w.ShowDialog();
        }
        void EditConnectionStringWindow_Saved(object sender, EditConnectionStringWindowSavedEventArgs e)
        {
            var index = this.ConnectionStringListBox.SelectedIndex;
            AValue.SchemaData.ConnectionStrings[index] = e.ConnectionString;
        }
        private void DeleteButton_Click(object sender, RoutedEventArgs e)
        {
            if (MessageBox.Show("Delete selected item?", "", MessageBoxButton.YesNo) == MessageBoxResult.Yes)
            {
                var item = this.ConnectionStringListBox.SelectedItem as String;
                AValue.SchemaData.ConnectionStrings.Remove(item);
            }
        }
        private void QuitButton_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
