﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using HigLabo.CodeGenerator;
using System.IO;

namespace HigLaboTest
{
    [TestClass]
    public class InterfacePropertyTest
    {
        [TestMethod]
        public void InterfacePropertyBasicFeature()
        {
            var p = new InterfaceProperty(new TypeName("String"), "DisplayName", true, true);

            var sw = new StringWriter();
            var cs = new CSharpSourceCodeGenerator(sw);
            cs.Write(p);
            Assert.AreEqual("String DisplayName { get; set; }" + sw.NewLine, sw.ToString());
        }
        [TestMethod]
        public void InterfacePropertyGetFeature()
        {
            var p = new InterfaceProperty(new TypeName("String"), "DisplayName", true, false);

            var sw = new StringWriter();
            var cs = new CSharpSourceCodeGenerator(sw);
            cs.Write(p);
            Assert.AreEqual("String DisplayName { get; }" + sw.NewLine, sw.ToString());
        }
    }
}
