﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using HigLabo.CodeGenerator;
using System.IO;

namespace HigLaboTest
{
    [TestClass]
    public class InterfaceTest
    {
        [TestMethod]
        public void InterfaceBasicFeature()
        {
            var c = new Interface("IPerson");

            var p = new InterfaceProperty("Int32", "Age", true, true);
            c.Properties.Add(p);

            var md = new InterfaceMethod("GetNumber");
            c.Methods.Add(md);

            var sw = new StringWriter();
            var cs = new CSharpSourceCodeGenerator(sw);
            cs.Write(c);

            Assert.AreEqual("public interface IPerson" + sw.NewLine
                + "{" + sw.NewLine
                + "    Int32 Age { get; set; }" + sw.NewLine
                + sw.NewLine
                + "    void GetNumber();" + sw.NewLine
                + "}" + sw.NewLine
                , sw.ToString());
        }
        [TestMethod]
        public void InterfaceIndent()
        {
            var c = new Interface("IPerson");

            var sw = new StringWriter();
            var cs = new CSharpSourceCodeGenerator(sw);
            cs.CurrentIndentLevel = 2;
            cs.Write(c);
            //static prefer
            Assert.AreEqual("        public interface IPerson" + sw.NewLine
                + "        {" + sw.NewLine
                + "        }" + sw.NewLine, sw.ToString());
        }
    }
}
