﻿using System;
using System.IO;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using HigLabo.CodeGenerator;

namespace HigLaboTest
{
    [TestClass]
    public class PropertyBodyTest
    {
        [TestMethod]
        public void TestPropertyBasicFeature()
        {
            var p = new PropertyBody(PropertyBodyType.Get);
            p.Body.Add(new CodeBlock(SourceCodeLanguage.CSharp, "return _Age;"));
            var sw = new StringWriter();
            var cs = new CSharpSourceCodeGenerator(sw);
            cs.CurrentIndentLevel = 1;
            cs.Write(p);

            Assert.AreEqual("    get" + sw.NewLine
                + "    {" + sw.NewLine
                + "        return _Age;" + sw.NewLine
                + "    }" + sw.NewLine
                , sw.ToString());
        }
        [TestMethod]
        public void TestAutomaticProperty()
        {
            var p = new PropertyBody(PropertyBodyType.Get);
            p.IsAutomaticProperty = true;
            var sw = new StringWriter();
            var cs = new CSharpSourceCodeGenerator(sw);
            cs.Write(p);

            Assert.AreEqual("get;" + sw.NewLine
                , sw.ToString());
        }
    }
}
