﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HigLabo.CodeGenerator
{
    public enum ClassNameType
    {
        /// <summary>
        /// 
        /// </summary>
        Object,
        /// <summary>
        /// 
        /// </summary>
        Boolean,
        /// <summary>
        /// 
        /// </summary>
        Byte,
        /// <summary>
        /// 
        /// </summary>
        ByteArray,
        /// <summary>
        /// 
        /// </summary>
        String,
        /// <summary>
        /// 
        /// </summary>
        Int16,
        /// <summary>
        /// 
        /// </summary>
        Int32,
        /// <summary>
        /// 
        /// </summary>
        Int64,
        /// <summary>
        /// 
        /// </summary>
        Single,
        /// <summary>
        /// 
        /// </summary>
        Double,
        /// <summary>
        /// 
        /// </summary>
        Decimal,
        /// <summary>
        /// 
        /// </summary>
        Guid,
        /// <summary>
        /// 
        /// </summary>
        TimeSpan,
        /// <summary>
        /// 
        /// </summary>
        DateTime,
        /// <summary>
        /// 
        /// </summary>
        DateTimeOffset,
        /// <summary>
        /// 
        /// </summary>
        DataTable,
    }
    /// <summary>
    /// 
    /// </summary>
    public static class ClassNameTypeExtensions
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="e"></param>
        /// <returns></returns>
        public static string ToClassNameString(this ClassNameType classNameType)
        {
            switch (classNameType)
            {
                case ClassNameType.Object: return "Object";
                case ClassNameType.Boolean: return "Boolean";
                case ClassNameType.Byte: return "Byte";
                case ClassNameType.ByteArray: return "Byte[]";
                case ClassNameType.String: return "String";
                case ClassNameType.Int16: return "Int16";
                case ClassNameType.Int32: return "Int32";
                case ClassNameType.Int64: return "Int64";
                case ClassNameType.Single: return "Single";
                case ClassNameType.Double: return "Double";
                case ClassNameType.Decimal: return "Decimal";
                case ClassNameType.Guid: return "Guid";
                case ClassNameType.TimeSpan: return "TimeSpan";
                case ClassNameType.DateTime: return "DateTime";
                case ClassNameType.DateTimeOffset: return "DateTimeOffset";
                case ClassNameType.DataTable: return "DataTable";
                default:
                    throw new ArgumentException();
            }
        }
        public static Boolean IsStructure(this ClassNameType classNameType)
        {
            switch (classNameType)
            {
                case ClassNameType.Object: return false;
                case ClassNameType.Boolean: return true;
                case ClassNameType.Byte: return true;
                case ClassNameType.ByteArray: return false;
                case ClassNameType.String: return false;
                case ClassNameType.Int16: return true;
                case ClassNameType.Int32: return true;
                case ClassNameType.Int64: return true;
                case ClassNameType.Single: return true;
                case ClassNameType.Double: return true;
                case ClassNameType.Decimal: return true;
                case ClassNameType.Guid: return true;
                case ClassNameType.TimeSpan:return true;
                case ClassNameType.DateTime: return true;
                case ClassNameType.DateTimeOffset: return true;
                case ClassNameType.DataTable: return false;
                default: throw new ArgumentException();
            }
        }
    }
}
