﻿using HigLabo.CodeGenerator;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HigLabo.DbSharp.CodeGenerator
{
    public abstract class ClassSourceCodeFileFactory
    {
        public abstract SourceCodeFile Create(String directoryPath, String namespaceName);

        public static void AddPropertyAndField(Class @class, IEnumerable<DataType> parameters)
        {
            var c = @class;
            Property p = null;
            Field f = null;
            String pName = "";

            foreach (var parameter in parameters)
            {
                pName = parameter.GetNameWithoutAtmark();
                f = new Field(parameter.GetClassName(), "_" + pName);
                if (f.TypeName.Name == "String")
                {
                    f.Initializer = "\"\"";
                }
                c.Fields.Add(f);

                p = new Property(parameter.GetClassName(), pName);
                p.Get.Body.Add(SourceCodeLanguage.CSharp, "return _{0};", pName);

                p.Set.Body.Add(SourceCodeLanguage.CSharp, "if (value == _{0}) return;", pName);
                p.Set.Body.Add(SourceCodeLanguage.CSharp, "_{0} = value;", pName);
                p.Set.Body.Add(SourceCodeLanguage.CSharp, "this.OnPropertyChanged();");
                c.Properties.Add(p);
            }
        }
    }
}
