﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HigLabo.DbSharp.CodeGenerator
{
    public class Table : DatabaseObject
    {
        public List<Column> Columns { get; private set; }
        public Table()
            : this("")
        {
        }
        public Table(String name)
        {
            this.Name = name;
            this.Columns = new List<Column>();
        }
        public IEnumerable<Column> GetColumns(Boolean? primaryKey, Boolean includeServerAutomaticallyInsertValueColumn)
        {
            if (primaryKey.HasValue == true)
            {
                if (includeServerAutomaticallyInsertValueColumn == true)
                {
                    return this.Columns.Where(el => el.IsPrimaryKey == primaryKey.Value);
                }
                else
                {
                    return this.Columns.Where(el => el.IsPrimaryKey == primaryKey.Value &&
                        el.IsServerAutomaticallyInsertValueColumn() == false);
                }
            }
            else
            {
                if (includeServerAutomaticallyInsertValueColumn == true)
                {
                    return this.Columns;
                }
                else
                {
                    return this.Columns.Where(el => el.IsServerAutomaticallyInsertValueColumn() == false);
                }
            }
        }
        public IEnumerable<Column> GetPrimaryKeyColumns()
        {
            return this.Columns.Where(el => el.IsPrimaryKey == true);
        }
    }
}
