﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HigLabo.DbSharp
{
    public abstract class Table : ITransaction
    {
        public abstract String TableName { get; }
        public String TransactionKey { get; set; }
        public Table()
        {
            this.TransactionKey = "";
        }
        public abstract List<TableRecord> SelectAllRecords();
        public abstract Int32 Insert(TableRecord record);
        public abstract Int32 Update(TableRecord record);
        public abstract Int32 Delete(TableRecord record);
    }
    public abstract class Table<T> : Table
        where T : TableRecord
    {
        public abstract List<T> SelectAll();
        public abstract Int32 Insert(T record);
        public abstract Int32 Update(T record);
        public abstract Int32 Delete(T record);

        public override List<TableRecord> SelectAllRecords()
        {
            return this.SelectAll().Select(el => (TableRecord)el).ToList();
        }
        public override Int32 Insert(TableRecord record)
        {
            return this.Insert((T)record);
        }
        public override Int32 Update(TableRecord record)
        {
            return this.Update((T)record);
        }
        public override Int32 Delete(TableRecord record)
        {
            return this.Delete((T)record);
        }
    }
}
