﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Data;
using HigLabo.Data;
using System.Data.SqlClient;

namespace HigLabo.DbSharp
{
    public abstract class StoredProcedure : INotifyPropertyChanged, ITransaction
    {
        /// <summary>
        /// 
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;
        /// <summary>
        /// 
        /// </summary>
        public abstract string GetStoredProcedureName();
        /// <summary>
        /// 
        /// </summary>
        String ITransaction.TransactionKey { get; set; }
        /// <summary>
        /// 
        /// </summary>
        protected StoredProcedure()
        {
            ((ITransaction)this).TransactionKey = "";
        }
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public abstract IDbCommand CreateCommand();
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Int32 ExecuteNonQuery()
        {
            IDatabase db = null;
            var affectedRecordCount = -1;

            try
            {
                db = DatabaseContext.GetDatabase(this.GetTransactionKey());
                var cm = CreateCommand();
                //TODO: Fire OnCommandCreated event
                var startTime = DateTimeOffset.Now;
                affectedRecordCount = db.ExecuteCommand(cm, !db.OnTransaction);
                var endTime = DateTimeOffset.Now;
                this.SetOutputParameterValue(cm);
                //TODO: Database.OnStoredProcedureExecuted(DbSharpMethodName.ExecuteCommand, this, startTime, endTime);
            }
            finally
            {
                if (db != null && db.OnTransaction == false)
                {
                    db.Dispose();
                }
            }
            return affectedRecordCount;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="command"></param>
        protected abstract void SetOutputParameterValue(IDbCommand command);
        /// <summary>
        /// 
        /// </summary>
        /// <param name="value"></param>
        /// <returns></returns>
        protected object ToDBValue(object value)
        {
            return value ?? DBNull.Value;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="value"></param>
        /// <returns></returns>
        public static T? ToEnum<T>(Object value)
            where T : struct
        {
            if (value == null)
            {
                return null;
            }
            T result;
            if (Enum.TryParse(value.ToString(), true, out result))
            {
                return result;
            }
            throw new InvalidEnumDataException(typeof(T), value);
        }
        protected String GetTransactionKey()
        {
            return ((ITransaction)this).TransactionKey;
        }
        protected void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            var eh = PropertyChanged;
            if (eh != null)
            {
                eh(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
