﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Data;
using HigLabo.Data;
using System.Data.SqlClient;

namespace HigLabo.DbSharp
{
    public abstract class StoredProcedureWithResultSet<T> : StoredProcedureWithResultSet
        where T : StoredProcedureResultSet, new()
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="resultSet"></param>
        /// <param name="reader"></param>
        protected abstract void SetResultSet(T resultSet, IDataReader reader);
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public abstract T CreateResultSet();
        /// <summary>
        /// 
        /// </summary>
        /// <param name="reader"></param>
        /// <returns></returns>
        protected override StoredProcedureResultSet CreateResultSets(IDataReader reader)
        {
            var rs = this.CreateResultSet();
            SetResultSet(rs, reader);
            return rs;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public new List<T> GetResultSets()
        {
            return EnumerateResultSets().ToList();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="database"></param>
        /// <returns></returns>
        public new List<T> GetResultSets(IDatabase database)
        {
            return EnumerateResultSets(database).ToList();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public new IEnumerable<T> EnumerateResultSets()
        {
            return base.EnumerateResultSets().Cast<T>();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="database"></param>
        /// <returns></returns>
        public new IEnumerable<T> EnumerateResultSets(IDatabase database)
        {
            return base.EnumerateResultSets(database).Cast<T>();
        }
    }
}
