﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Globalization;

namespace HigLabo.Wpf.Core
{
    public class DateConverter : System.Windows.Data.IValueConverter
    {
        public String Format { get; set; }
        public String TextWhenNull { get; set; }
        public DateConverter()
        {
            this.Format = "yyyy/MM/dd";
        }
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null) { return this.TextWhenNull; }

            if (typeof(DateTime).Equals(value.GetType()) == false &&
                typeof(DateTime).Equals(value.GetType()) == false)
            {
                throw new ArgumentException("Value must be of type DateTime.", "value");
            }

            DateTime dt = (DateTime)value;

            if (parameter == null)
            {
                if (dt.Year < 1900)
                {
                    return "N/A";
                }
                return dt.ToString(this.Format);
            }
            return dt.ToString(this.Format);
        }
        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string strValue = value as string;
            DateTime resultDateTime;
            if (DateTime.TryParse(strValue, out resultDateTime))
            {
                return resultDateTime;
            }
            return DependencyProperty.UnsetValue;
        }
    }
}
